]> git.donarmstrong.com Git - deb_pkgs/autorandr.git/blob - autorandr
simplify config extraction from xrandr
[deb_pkgs/autorandr.git] / autorandr
1 #!/bin/sh
2 #
3 # Automatically select a display configuration based on connected devives
4 #
5 # Stefan Tomanek <stefan.tomanek@wertarbyte.de>
6 #
7 # How to use:
8 #
9 # Save your current display configuration and setup with:
10 #  $ autorandr --save mobile
11 #
12 # Connect an additional display, configure your setup and save it:
13 #  $ autorandr --save docked
14 #
15 # Now autorandr can detect which hardware setup is active:
16 #  $ autorandr
17 #    mobile
18 #    docked (detected)
19 #
20 # To automatically reload your setup, just append --change to the command line
21 #
22 # To manually load a profile, you can use the --load <profile> option.
23 #
24 # autorandr tries to avoid reloading an identical configuration. To force the
25 # (re)configuration, apply --force.
26 #
27 # To prevent a profile from being loaded, place a script call "block" in its
28 # directory. The script is evaluated before the screen setup is inspected, and
29 # in case of it returning a value of 0 the profile is skipped. This can be used
30 # to query the status of a docking station you are about to leave.
31 #
32 # If no suitable profile can be identified, the current configuration is kept.
33 # To change this behaviour and switch to a fallback configuration, specify
34 # --default <profile>
35 #
36 # Another script called "postswitch "can be placed in the directory
37 # ~/.autorandr as well as in all profile directories: The scripts are executed
38 # after a mode switch has taken place and can notify window managers or other
39 # applications about it.
40 #
41 #
42 # While the script uses xrandr by defult, calling it by the name "autodisper"
43 # or "auto-disper" forces it to use the "disper" utility, which is useful for
44 # controlling nvidia chipsets. The formats for fingerprinting the current setup
45 # and saving/loading the current configuration are adjusted accordingly.
46
47 XRANDR=/usr/bin/xrandr
48 DISPER=/usr/bin/disper
49 PROFILES=~/.autorandr/
50 CONFIG=~/.autorandr.conf
51
52 CHANGE_PROFILE=0
53 FORCE_LOAD=0
54 DEFAULT_PROFILE=""
55 SAVE_PROFILE=""
56
57 FP_METHODS="setup_fp_xrandr_edid setup_fp_sysfs_edid"
58 CURRENT_CFG_METHOD="current_cfg_xrandr"
59 LOAD_METHOD="load_cfg_xrandr"
60
61 SCRIPTNAME="$(basename $0)"
62 # when called as autodisper/auto-disper, we assume different defaults
63 if [ "$SCRIPTNAME" = "auto-disper" ] || [ "$SCRIPTNAME" = "autodisper" ]; then
64         echo "Assuming disper defaults..." >&2
65         FP_METHODS="setup_fp_disper"
66         CURRENT_CFG_METHOD="current_cfg_disper"
67         LOAD_METHOD="load_cfg_disper"
68 fi
69
70 if [ -f $CONFIG ]; then
71         echo "Loading configuration from '$CONFIG'" >&2
72         . $CONFIG
73 fi
74
75 setup_fp_xrandr_edid() {
76         $XRANDR -q --verbose | awk '
77         /^[^ ]+ (dis)?connected / { DEV=$1; }
78         $1 ~ /^[a-f0-9]+$/ { ID[DEV] = ID[DEV] $1 }
79         END { for (X in ID) { print X " " ID[X]; } }'
80 }
81
82 setup_fp_sysfs_edid() {
83         # xrandr triggers the reloading of EDID data
84         $XRANDR -q > /dev/null
85         # hash the EDIDs of all _connected_ devices
86         for P in /sys/class/drm/card*-*/; do
87                 # nothing found
88                 [ ! -d "$P" ] && continue
89                 if grep -q "^connected$" < "${P}status"; then
90                         echo -n "$(basename "$P") "
91                         md5sum ${P}edid | awk '{print $1}'
92                 fi
93         done
94 }
95
96 setup_fp_disper() {
97         $DISPER -l | grep '^display '
98 }
99
100 setup_fp() {
101         local FP="";
102         for M in $FP_METHODS; do
103                 FP="$($M)"
104                 if [ -n "$FP" ]; then
105                         break
106                 fi
107         done
108         if [ -z "$FP" ]; then
109                 echo "Unable to fingerprint display configuration" >&2
110                 return
111         fi
112         echo "$FP"
113 }
114
115 current_cfg_xrandr() {
116         $XRANDR -q | awk '
117         # display is connected and has a mode
118         /^[^ ]+ connected [^(]/ {
119                 split($3, A, "+");
120                 print "output "$1;
121                 print "mode "A[1];
122                 print "pos "A[2]"x"A[3];
123                 next;
124         }
125         # disconnected or disabled displays
126         /^[^ ]+ (dis)?connected / {
127                 print "output "$1;
128                 print "off";
129                 next;
130         }'
131 }
132
133 current_cfg_disper() {
134         $DISPER -p
135 }
136
137 current_cfg() {
138         $CURRENT_CFG_METHOD;
139 }
140
141 blocked() {
142         local PROFILE="$1"
143         [ ! -x "$PROFILES/$PROFILE/block" ] && return 1
144
145         "$PROFILES/$PROFILE/block" "$PROFILE"
146 }
147
148 config_equal() {
149         local PROFILE="$1"
150         if [ "$(cat "$PROFILES/$PROFILE/config")" = "$(current_cfg)" ]; then
151                 echo "Config already loaded"
152                 return 0
153         else
154                 return 1
155         fi
156 }
157
158 load_cfg_xrandr() {
159         sed 's!^!--!' "$1" | xargs $XRANDR
160 }
161
162 load_cfg_disper() {
163         $DISPER -i < "$1"
164 }
165
166 load() {
167         local PROFILE="$1"
168         local CONF="$PROFILES/$PROFILE/config"
169         if [ -e "$CONF" ] ; then
170                 echo " -> loading profile $PROFILE"
171                 $LOAD_METHOD "$CONF"
172
173                 [ -x "$PROFILES/$PROFILE/postswitch" ] && \
174                         "$PROFILES/$PROFILE/postswitch" "$PROFILE"
175                 [ -x "$PROFILES/postswitch" ] && \
176                         "$PROFILES/postswitch" "$PROFILE"
177         fi
178 }
179
180 help() {
181         cat <<EOH
182 Usage: $SCRIPTNAME [options]
183
184 -h, --help              get this small help
185 -c, --change            reload current setup
186 -s, --save <profile>    save your current setup to profile <profile>
187 -l, --load <profile>    load profile <profile>
188 -d, --default <profile> make profile <profile> the default profile 
189 --force                 force (re)loading of a profile
190 --fingerprint           fingerprint your current hardware setup
191
192  To prevent a profile from being loaded, place a script call "block" in its
193  directory. The script is evaluated before the screen setup is inspected, and
194  in case of it returning a value of 0 the profile is skipped. This can be used
195  to query the status of a docking station you are about to leave.
196
197  If no suitable profile can be identified, the current configuration is kept.
198  To change this behaviour and switch to a fallback configuration, specify
199  --default <profile>.
200
201  Another script called "postswitch "can be placed in the directory
202  ~/.autorandr as well as in any profile directories: The scripts are executed
203  after a mode switch has taken place and can notify window managers.
204
205  When called by the name "autodisper" or "auto-disper", the script uses "disper"
206  instead of "xrandr" to detect, configure and save the display configuration.
207
208 EOH
209         exit
210 }
211 # process parameters
212 OPTS=$(getopt -n autorandr -o s:l:d:cfh --long change,default:,save:,load:,force,fingerprint,help -- "$@")
213 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
214 eval set -- "$OPTS"
215
216 while true; do
217         case "$1" in
218                 -c|--change) CHANGE_PROFILE=1; shift ;;
219                 -d|--default) DEFAULT_PROFILE="$2"; shift 2 ;;
220                 -s|--save) SAVE_PROFILE="$2"; shift 2 ;;
221                 -l|--load) LOAD_PROFILE="$2"; shift 2 ;;
222                 -h|--help) help ;; 
223                 --force) FORCE_LOAD=1; shift ;;
224                 --fingerprint) setup_fp; exit 0;;
225                 --) shift; break ;;
226                 *) echo "Error: $1"; exit 1;;
227         esac
228 done
229
230 CURRENT_SETUP="$(setup_fp)"
231
232 if [ -n "$SAVE_PROFILE" ]; then
233         echo "Saving current configuration as profile '${SAVE_PROFILE}'"
234         mkdir -p "$PROFILES/$SAVE_PROFILE"
235         echo "$CURRENT_SETUP" > "$PROFILES/$SAVE_PROFILE/setup"
236         $CURRENT_CFG_METHOD > "$PROFILES/$SAVE_PROFILE/config"
237         exit 0
238 fi
239
240 if [ -n "$LOAD_PROFILE" ]; then
241         CHANGE_PROFILE=1 FORCE_LOAD=1 load "$LOAD_PROFILE"
242         exit $?
243 fi
244
245 for SETUP_FILE in $PROFILES/*/setup; do
246         if ! [ -e $SETUP_FILE ]; then
247                 break
248         fi
249         PROFILE="$(basename $(dirname "$SETUP_FILE"))"
250         echo -n "$PROFILE"
251
252         if blocked "$PROFILE"; then
253                 echo " (blocked)"
254                 continue
255         fi
256
257         FILE_SETUP="$(cat "$PROFILES/$PROFILE/setup")"
258         if [ "$CURRENT_SETUP" = "$FILE_SETUP" ]; then
259                 echo " (detected)"
260                 if [ "$CHANGE_PROFILE" -eq 1 ]; then
261                         if [ "$FORCE_LOAD" -eq 1 ] || ! config_equal "$PROFILE"; then
262                                 load "$PROFILE"
263                         fi
264                 fi
265                 # found the profile, exit with success
266                 exit 0
267         else
268                 echo ""
269         fi
270 done
271
272 # we did not find the profile, load default
273 if [ -n "$DEFAULT_PROFILE" ]; then
274         echo "No suitable profile detected, falling back to $DEFAULT_PROFILE"
275         load "$DEFAULT_PROFILE"
276 fi
277 exit 1